<template lang="pug">
  div
    form.form-horizontal
      .divider.text-center(data-content="Profile")
      .form-group
        .col-3.col-sm-12
          Avatar(size="xl" :name="displayName.substring(0, 2).toUpperCase()" :src="getAvatar && baseURL + getAvatar")
        .col-9.col-sm-12
          .input-group
            z-input#profileImage(type="file" style="flex-grow:1" accept=".png, .jpg, .jpeg" @input="onFileChange" v-validate="'dimensions:300,300|ext:jpeg,jpg,png|image'" data-vv-as="image" ref="profileImage" name="profileImage")
            //- button.btn.btn-primary.input-group-btn(disabled) {{ $t('delete image') | capitalize({ onlyFirstLetter: true }) }}
      .form-group
        .col-3.col-sm-12
          label {{ $t('display name') | capitalize({ onlyFirstLetter: true }) }}
        .col-9.col-sm-12
          z-input(v-validate="'max:30'" name="profileName" :placeholder="displayName" v-model="profile.name" maxlength="30")
      .form-group
        .col-3.col-sm-12
          label {{ $t('description') | capitalize({ onlyFirstLetter: true }) }}
        .col-9.col-sm-12
          vue-simplemde(v-model="profile.bio" ref="markdownEditor")
          z-switch(v-model="profile.indexed")
            .label-text {{ $t('indexable') | capitalize({ onlyFirstLetter: true }) }}
            .label-hint {{ $t('indexable help') | capitalize({ onlyFirstLetter: true }) }}
          z-switch(v-model="profile.private")
            .label-text {{ $t('exposure') | capitalize({ onlyFirstLetter: true }) }}
            .label-hint {{ $t('exposure help') | capitalize({ onlyFirstLetter: true }) }}
      .form-group
        .col-12
          z-button(v-if="showAll" v-on:click.native="editProfile" type="button" color="primary") {{ $t('save') }}
    form.form-horizontal(v-if="showAll")
      .divider.text-center(data-content="Password")
      .form-group
        .col-3.col-sm-12
          label {{ $t('new password') | capitalize({ onlyFirstLetter: true }) }}
        .col-9.col-sm-12
          z-input(v-model="newPassword" type="password" name="password" placeholder="Password")
        .col-3.col-sm-12
        .col-9.col-sm-12
          z-input(v-model="reNewPassword" type="password" v-validate="{ is: newPassword }" name="passwordRepeat" placeholder="Password (repeat)")
      .form-group
        .col-12
          z-button(type="button" color="primary" @click="localChangePassword") {{ $t('save') }}
    form.form-horizontal(v-if="showAll")
      .divider.text-center(data-content="Danger Zone")
      .form-group
        .col-3.col-sm-12
        .col-9.col-sm-12
          p(style="text-align:left") {{ $t('delete account help') | capitalize({ onlyFirstLetter: true }) }}
      .form-group
        .col-12
          div.input-group
            z-input(type="password" name="passwordDelete" v-model="deletePassword" placeholder="Password" required)
            LongpressButton.btn.btn-primary.input-group-btn(
              type="submit"
              duration="2" pressingText="Keep pressing to delete" actionText="Deleting, please wait..."
              :onConfirm="deleteAccountWrapper"
            ) {{ $t('delete account') | capitalize({ onlyFirstLetter: true }) }}
</template>

<script>
/* eslint-disable */
import environment from '~/mixins/environment'

import Avatar from '~/components/Avatar'
import LongpressButton from '~/components/LongpressButton'
import VueSimplemde from 'vue-simplemde'

import { mapState, mapActions, mapGetters } from 'vuex'

export default {
  components: {
    // logic components:
    Avatar,
    LongpressButton,
    VueSimplemde
  },
  mixins: [environment],
  props: {
    showAll: {
      type: Boolean,
      default: true
    }
  },
  data: function() {
    return {
      // editor-related

      // profile-related
      profile: {
        image: '',
        name: null,
        bio: null, // also used as editor text
        indexed: false,
        private: false
      },

      // password-related
      deletePassword: null,
      newPassword: null,
      reNewPassword: null
    }
  },
  computed: {
    ...mapState('profile', ['data']),
    valid() {
      return !this.errors.any()
    },
    simplemde() {
      return this.$refs.markdownEditor.simplemde
    },
    ...mapGetters('profile', ['getAvatar']),
    ...mapGetters('user', ['displayName'])
  },
  mounted() {
    this.update()
  },
  methods: {
    next() {
      /**
       * next() is used in account/setup.vue to call the main action
       * of a component under its governance. It is mostly used to click
       * "save" while replacing the save button by its own.
       */
      this.editProfile()
    },
    editProfile() {
      this.$validator.validate().then(async valid => {
        if (!valid) {
          console.log(this.errors.all())
          this.$toast.error('Your information still has formatting issues', {
            icon: 'warning'
          })
        } else {
          this.$nextTick(async () => {
            this.$nuxt.$loading.start()

            await this.setRemote({
              input: {
                name: this.profile.name,
                bio: this.profile.bio,
                image: this.profile.image,
                indexed: this.profile.indexed,
                private: this.profile.private
              }
            })
            await this.$store.dispatch('auth/syncUser')
            this.$toast.success('Successfully updated your information', {
              icon: 'check'
            })

            // resetting the image input
            this.$refs.profileImage.inputValue = ''
            this.profile.image = undefined

            this.$nuxt.$loading.finish()
          })
        }
      })
    },
    async update() {
      await this.$store.dispatch('auth/syncUser')
      this.profile.name = this.data.name
      this.profile.bio = this.data.bio
      this.profile.indexed = this.data.indexed
      this.profile.private = this.data.private
    },
    localChangePassword() {
      this.$validator.validate().then(async valid => {
        try {
          if (!valid) {
            this.$toast.error('Your information still has formatting issues', {
              icon: 'warning'
            })
          } else {
            const res = await this.changePassword({
              newPassword: this.newPassword,
              reNewPassword: this.reNewPassword
            })
            if (res.succes) {
              this.$toast.success('Successfully changed password', {
                icon: 'check'
              })
            } else {
              this.$toast.error('Some error occured', { icon: 'warning' })
            }
          }
        } catch (e) {
          console.log(e)
        }
      })
    },
    async deleteAccountWrapper() {
      try {
        const res = await this.deleteAccount(this.deletePassword)
        if (res && res.deleteAccount.success) {
          this.$toast.success('Successfully deleted your account', {
            icon: 'check'
          })
        } else {
          this.$toast.error('Some error occured', { icon: 'warning' })
        }
      } catch (e) {
        console.log(e)
      }
    },
    onFileChange() {
      this.profile.image = this.$refs.profileImage.$refs.input.files[0]
    },
    ...mapActions('profile', ['setRemote', 'changePassword']),
    ...mapActions('auth', ['verify', 'deleteAccount']),

    /* editor-related methods */
    getBioHtml() {
      let html = this.$refs.bioEditor.invoke('getHtml')
    }
  },
  $_veeValidate: {
    validator: 'new'
  }
}
</script>

<style lang="postcss" scoped>
#deleteImage {
  height: 37px;
}
</style>

<style>
@import 'simplemde/dist/simplemde.min.css';

.markdown-editor {
  text-align: left;
}
</style>
